;Landing Game ChrPut.

	;文字型変数bfにキャラクターデータを読み込む
	sdim bf,64000 :bload "chr.bin",bf

	dim map,768		; 32×24=768
	hi=0

*start
	stg=0 :sc=0 :e=0 :ov=0

; 面生成
*stgmk
	stg=stg+1 :x=15 :w=13-(stg/3) :if w<5 :w=5
	repeat 672 :map(96+cnt)=1 :loop		; 32*21=672
	repeat 20
		y=3+cnt :x=x+(rnd(5)-2) :ww=w-(cnt/8)
		repeat ww
			xx=x-(ww/2) :if xx<0 :xx=0
			map(y*32+xx+cnt)=0
		loop
	loop

	; 得点計算
	sc=sc+e :if sc>hi :hi=sc

	; 着陸船 変数初期化
	px=320 :py=15 :gx=0 :gy=0 :e=500 :key=0

	; 画面表示
	redraw 1 :gosub *stgpr :x=px :y=py :gosub *ship
	title "STAGE:"+stg+" HIT SPACE KEY TO START!"
	gosub *pause

; メインループ
	repeat
		title "STAGE:"+stg+" ENERGY:"+e+" SCORE:"+sc+" HIGH-SCORE:"+hi
		redraw 0 :gosub *stgpr

		; 重力
		gy=gy+(gy<30)

		; 慣性移動
		px=px+(gx/2) :py=py+(gy/3)
		if px<0 :px=0
		if px>640 :px=640
		if py<0 :py=0

		; 当たり判定
		if py>445 {
			if abs(gy)<8 {
				title "GOOD LANDING!" :wait 300 :break
			} else {
				gosub *bomb :break
			}
		} else {
			x=px/20 :y=py/20
			if map(y*32+x)=1 :gosub *bomb :break
		}

		x=px :y=py :gosub *ship

		redraw 1
		wait 10
	loop

	; GAME OVER なら *start へ
	if ov=1 :goto *start :else :goto *stgmk

stop

; スペースキー押下待ち
*pause
	wait 100
	repeat
		stick key :if key & 16 :break
		wait 5
	loop
	return

; 面表示
*stgpr
	color 80,40,40 :boxf 0,0,640,480
	color
	repeat 768
		x=20*(cnt\32) :y=20*(cnt/32)
		if map(cnt)=0 :boxf x,y,x+19,y+19
	loop
	return

; 着陸船 表示
*ship
	sz=2 :cno=4 :gosub *chrput
	color 255,255,0

	stick key
	if e>1 {
		if key & 1 :e=e-1 :gx=gx+(gx<20) :boxf x-18,y+8,x-20-rnd(6),y+10
		if key & 4 :e=e-1 :gx=gx-(gx>-20) :boxf x+18,y+8,x+20+rnd(6),y+10
		if key & 26 {
			e=e-2 :gy=gy-2*(gy>-10)
			boxf x-1,y+13,x+1,y+23+rnd(10)
			line x,y+13,x+rnd(10)-5,y+13+rnd(10)
		}
	}
	return

; 着陸船 粉々
*bomb
	color 160,160,160
	repeat 9
		rx=rnd(30)-15 :ry=rnd(30)-15 :b=1+rnd(6)
		x=px+rx-3 :y=py+ry-3
		boxf x,y,x+b,y+b
	loop
	redraw 1
	gosub *pause :ov=1
	return

;キャラクター表示ルーチン
; sz=1ドットのサイズ
; x,y=表示する座標
; cno=キャラクター番号
*chrput
	xs=peek(bf,0) :m=xs*(xs/7) :cln=m*2+8 :adr=cno*cln

	;RGB色情報ゲット
	repeat 3
		a=peek(bf,adr+1+cnt)&63
		r(cnt)=80*(a/16)+15 :g(cnt)=80*((a&12)/4)+15 :b(cnt)=80*(a&3)+15
	loop

	;キャラクタービット計算＆表示
	i=0
	repeat m
		c1=peek(bf,adr+4+cnt) :c2=peek(bf,adr+4+m+cnt)
		a=64
		repeat 7
			xx=x-(xs*sz/2)+(i\xs)*sz :yy=y-(xs*sz/2)+(i/xs)*sz
			c=((c1&a)>0)+2*((c2&a)>0)
			if c>0 {
				color r(c-1),g(c-1),b(c-1)
				boxf xx,yy,xx+sz-1,yy+sz-1
			}
			a=a/2 :i=i+1
		loop
	loop
	return
